#include <cstdio>
#include <algorithm>
#include <string.h>
using namespace std;

#define Nmax 100010

int n, m;
int G[Nmax];

void citire () {
	
	int i, x, y, sol = 0, bla;
	scanf ("%d %d", &n, &m);
	for (i = 1; i <= m; i++) {
		scanf ("%d %d", &x, &y);
		G[x]++;
		G[y]++;
	}
	
	for (i = 1; i <= n; i++) {
		if (G[i]&1) bla = G[i] / 2 + 1;
		else bla = G[i] / 2;
		
		sol = max (sol ,bla);
	}
	
	printf ("%d\n", sol);
}

int main () {

	freopen ("dag.in", "r", stdin);
	freopen ("dag.out", "w", stdout);
	
	citire ();
	
	return 0;
}
